//+------------------------------------------------------------------+
//|                                                     HMA bars.mq4 |
//| www.forex-station.com                                            |
//+------------------------------------------------------------------+
#property  copyright "mladen"
#property  link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 4

#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  3
#property indicator_width4  3

//
//
//
//
//

extern int HMAPeriod  = 20;
extern int HMAPrice   = PRICE_CLOSE;
extern int HMAMethod  = MODE_LWMA;
input int             WickWidth        = 1;                 // Candle wick width
input int             BodyWidth        = 2;                 // If auto width = false then use this
input bool            UseAutoWidth     = true;              // Auto adjust candle body width
extern color           color1                = clrGreen;      // Bearish candle wick color
extern color           color2                = clrDarkOrange;      // Bullish candle wick color
extern color           color3                = clrGreen;      // Bearish candle body color
extern color           color4                = clrDarkOrange;      // Bullish candle body color
//
//
//
//
//

double bufferU1[];
double bufferU2[];
double bufferD1[];
double bufferD2[];
double buffer1[];
double buffer2[];
int    HalfPeriod;
int    HullPeriod;
int candlewidth=0;
string DisplayID = "HMA bars";

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
if (UseAutoWidth)
   {
      int scale = int(ChartGetInteger(0,CHART_SCALE));
      switch(scale) 
	   {
	      case 0: candlewidth =  1; break;
	      case 1: candlewidth =  1; break;
		   case 2: candlewidth =  2; break;
		   case 3: candlewidth =  3; break;
		   case 4: candlewidth =  6; break;
		   case 5: candlewidth = 14; break;
	   }
	}
	else { candlewidth = BodyWidth; }
   if (ObjectFind(DisplayID)!=0)
   {
      ObjectCreate(ChartID(),DisplayID,OBJ_BUTTON,0,0,0);
         ObjectSetString(ChartID(),DisplayID,OBJPROP_TEXT,"Hma bars on");
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_FONTSIZE,10);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_CORNER,0);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_COLOR,clrWhite);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_BGCOLOR,clrDimGray);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_YDISTANCE,108);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_XDISTANCE,2);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_XSIZE,80);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_YSIZE,20);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_HIDDEN,true);
         ObjectSetInteger(ChartID(),DisplayID,OBJPROP_STATE,true);
   }         

   IndicatorBuffers(6);
      SetIndexBuffer(0,bufferU2); 
      SetIndexBuffer(1,bufferD2); 
      SetIndexBuffer(2,bufferU1); 
      SetIndexBuffer(3,bufferD1); 
      SetIndexBuffer(4,buffer1);
      SetIndexBuffer(5,buffer2);
      
      if (GetButtonState(DisplayID)!="off")
      {
         SetIndexStyle(0,DRAW_HISTOGRAM, 0, WickWidth, color1);
         SetIndexStyle(1,DRAW_HISTOGRAM, 0, WickWidth, color2);
         SetIndexStyle(2,DRAW_HISTOGRAM, 0, candlewidth, color3);
         SetIndexStyle(3,DRAW_HISTOGRAM, 0, candlewidth, color4);
      }
      else for (int i=0; i<4; i++) SetIndexStyle(i,DRAW_NONE);

   //
   //
   //
   //
   //
         
   HMAPeriod  = MathMax(2,HMAPeriod);
   HalfPeriod = MathFloor(HMAPeriod/2);
   HullPeriod = MathFloor(MathSqrt(HMAPeriod));
   return(0);
}
void OnDeinit(const int reason)
{ 
      switch(reason)
      {
         case REASON_PARAMETERS  :
         case REASON_CHARTCHANGE :
         case REASON_RECOMPILE   :
         case REASON_CLOSE       : break;
         default :
         {
            ObjectDelete(DisplayID);
         }                  
      }
}

//
//
//

void OnChartEvent(const int id, const long& lparam, const double& dparam, const string& sparam)
{
   static string prevState ="";
   if (id==CHARTEVENT_OBJECT_CLICK && sparam==DisplayID)
   {
      string newState = GetButtonState(DisplayID);
         if (newState!=prevState)
         if (newState=="off")
         { SetIndexStyle(0,DRAW_NONE);      
           SetIndexStyle(1,DRAW_NONE); 
           SetIndexStyle(2,DRAW_NONE);  
           SetIndexStyle(3,DRAW_NONE);  
           prevState=newState; 
         }
         else  
         { 
            SetIndexStyle(0,DRAW_HISTOGRAM); 
            SetIndexStyle(1,DRAW_HISTOGRAM); 
            SetIndexStyle(2,DRAW_HISTOGRAM); 
            SetIndexStyle(3,DRAW_HISTOGRAM); 
            prevState=newState; 
         }
            ObjectSetString(ChartID(),DisplayID,OBJPROP_TEXT,"Hma bars "+newState);
   }
}  

//
//
//
//
//

int start()
{
if(ChartGetInteger(0,CHART_SCALE) != candlewidth) init(); 
   int counted_bars = IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;   
           limit=Bars-counted_bars;

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--) buffer2[i] = iMA(NULL,0,HalfPeriod,0,HMAMethod,HMAPrice,i)*2-
                                        iMA(NULL,0,HMAPeriod ,0,HMAMethod,HMAPrice,i);
   for(i=limit; i>=0; i--)
   {
      buffer1[i]  = iMAOnArray(buffer2,0,HullPeriod,0,HMAMethod,i);
      bufferU1[i] = EMPTY_VALUE;
      bufferU2[i] = EMPTY_VALUE;
      bufferD1[i] = EMPTY_VALUE;
      bufferD2[i] = EMPTY_VALUE;
      
      //
      //
      //
      //
      //
      
        if (buffer1[i]>buffer1[i+1])
         {
            bufferU1[i] = MathMax(Open[i],Close[i]);
            bufferD1[i] = MathMin(Open[i],Close[i]);
            bufferU2[i] = High[i];
            bufferD2[i] = Low[i];
         }
         if (buffer1[i]<buffer1[i+1])
         {
            bufferU1[i] = MathMin(Open[i],Close[i]);
            bufferD1[i] = MathMax(Open[i],Close[i]);
            bufferU2[i] = Low[i];
            bufferD2[i] = High[i];
         }
   }      
   return(0);
}

//
//
//

string GetButtonState(string whichbutton)
{
      bool selected=ObjectGetInteger(ChartID(),whichbutton,OBJPROP_STATE);
      if (selected)
         {return ("on");} 
      else
         {return ("off");}
}